<template>
  <div id="app-header">
    <b-navbar  sticky toggleable="lg">
      <b-navbar-brand v-if="logoUrl!=null">
        <router-link class="d-none d-lg-block"
          to="/"
          custom
          v-slot="{ navigate }"
        >
          <img
            :src="logoUrl"
            alt="Logo"
            @click="navigate"
            role="link"
          >
        </router-link>
      </b-navbar-brand>
      <b-navbar-toggle target="nav-collapse">
        <template>
          <b-icon icon="list" variant="white"></b-icon>
        </template>
      </b-navbar-toggle>
      <h1 v-if="currentRouteName=='Map'" class="mb-0 font_size_18 uppercase text-first mr-5">
            {{mapTitle}}
        </h1>
        <b-collapse id="nav-collapse" is-nav>
            <b-navbar-nav class="ml-auto">
                <b-nav-item v-if="contextService.user!=null">
                    <a @click="newMap();" v-b-tooltip.hover title="Nouvelle carte">
                      <b-icon icon="plus-square"></b-icon>&nbsp;
                      <span class="d-lg-none">Nouvelle carte</span>
                    </a>
                </b-nav-item>
                <b-nav-item>
                    <a @click="redirect('#/maps/');" v-b-tooltip.hover title="Cartes">
                      <b-icon icon="house"></b-icon>&nbsp;
                      <span class="d-lg-none">Cartes</span>
                    </a>
                </b-nav-item>
                <b-nav-item>
                    <a @click="redirect('/portail/fr/accueil');"
                      v-b-tooltip.hover title="Catalogue">
                      <b-icon icon="book"></b-icon>&nbsp;
                      <span class="d-lg-none">Catalogue</span>
                    </a>
                </b-nav-item>
                 <b-nav-item v-if="contextService.configuration.documentation_url.length>0">
                    <a @click="help();"
                      v-b-tooltip.hover title="Aide">
                    <b-icon icon="question-circle"></b-icon></a>
                </b-nav-item>
                <b-nav-item v-if="contextService.user==null">
                    <!-- <b-icon icon="box-arrow-in-right"></b-icon>&nbsp; -->
                    <b-icon icon="person-circle"></b-icon>&nbsp;
                    <a @click="login();">Se connecter</a>
                </b-nav-item>

                <b-nav-item-dropdown v-if="contextService.user!=null" right>
                    <template #button-content>
                        <b-icon icon="person-circle"></b-icon>&nbsp; {{contextService.user.email}}
                    </template>

                    <b-dropdown-item-button @click="profile();" class="text-second">
                        <span class="font_size_15">
                          <b-icon icon="person-lines-fill"></b-icon>
                        </span> &nbsp;Profil
                    </b-dropdown-item-button>
                    <b-dropdown-item-button @click="redirect('/onegeo-publish/data');" class="text-second">
                        <span class="font_size_15">
                          <b-icon icon="layers"></b-icon>
                        </span> &nbsp;Publier des données
                    </b-dropdown-item-button>
                    <b-dropdown-divider v-if="canEditMap || canDeleteMap" ></b-dropdown-divider>
                    <b-dropdown-item-button v-if="canEditMap" @click="edit()" class="text-second">
                        <span class="font_size_15">
                          <b-icon icon="pencil"></b-icon>
                        </span>  &nbsp;Éditer la carte
                    </b-dropdown-item-button>
                    <b-dropdown-item-button class="text-second"
                      v-if="canDeleteMap" @click="deleteMap()">
                        <span class="font_size_15">
                          <b-icon icon="trash"></b-icon>
                        </span>  &nbsp;Supprimer la carte
                    </b-dropdown-item-button>

                    <b-dropdown-divider></b-dropdown-divider>

                    <b-dropdown-item-button variant="danger" @click="logout();">
                        <b-icon icon="power" aria-hidden="true"></b-icon> Déconnexion
                    </b-dropdown-item-button>
                </b-nav-item-dropdown>
            </b-navbar-nav>
        </b-collapse>
    </b-navbar>
    <div  v-if="contextService.isEditionActive"
        role="alert" aria-live="polite"
        aria-atomic="true"
        class="alert position-fixed fixed-top rounded-0
        alert-dismissible alert-info text-center"
        style="z-index: 2000;padding: 5px;opacity: 0.95;width: 600px;margin:auto">
    <span  style="cursor:pointer !important;">
      <b-icon icon="info-circle" id="info_icon_save" variant="info"></b-icon> &nbsp;
    </span>&nbsp;
    <span class="uppercase" style="font-weight:bold">Carte en cours de modification</span>&nbsp;

    <b-popover target="info_icon_save" triggers="hover" boundary="window" style="z-index:2060"
      placement="right" :delay="{ show: 50, hide: 500 } ">
      <template #title>
        <b-badge
          variant="info">Comment configurer la carte ?</b-badge>
      </template>
        <span class="">Vous pouvez configurer les réglages généraux de la carte <b-icon icon="gear" variant="info"></b-icon>,
      les modules activés <b-icon icon="puzzle" variant="info"></b-icon> et les données affichées dans la carte <b-icon icon="layers" variant="info"></b-icon> en activant les panneaux de configuration dans le menu de gauche</span>
    </b-popover>
      <b-button size="sm"
        v-b-tooltip.hover
        variant="outlined-primary"
        class="w-20 bg_color-first-outlined"
        title="Annuler"
        @click="cancelEdition()"
        >
          <b-icon icon="arrow-counterclockwise"/>
      </b-button>
    &nbsp;
    <b-button size="sm"
      v-b-tooltip.hover
      variant="outlined-primary"
      class="w-20 bg_color-first-outlined"
      title="Sauver"
      @click="saveContext()"
      >
        <b-icon icon="check2"/>
    </b-button>
    &nbsp;<b-button class="font_size_13 btn btn-success" style="width:180px" v-if="beta"
    @click="downloadContext()">Telecharger le contexte</b-button>
    </div>
</div>
</template>
<script lang="ts">
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import Application from '@/models/map-context/Application';
import { EventBus, EVENTS } from '@/services/EventBus';
import FileSaver from 'file-saver';
import Component from 'vue-class-component';
import BaseComponent from './BaseComponent';

@Component
export default class Header extends BaseComponent {
  logoUrl = null;// = 'img/logo_pigma.png';

  created() {
    // this.mapService = mapservice;
  }

  edit() {
    this.contextService.startEdition();
    EventBus.$emit(EVENTS.OPEN_LEFT_SIDE_MENU, 'SettingsPanel');
    console.log(this.contextService.user);
  }

  deleteMap() {
    if (window.confirm('Confirmez vous la suppression de cette carte?')) {
      this.contextService.deleteCurrentMap().then((x) => this.$router.push({ path: '/maps' }));
    }
  }

  newMap() {
    this.$router.push({ path: '/map/new' });
  }

  help() {
    window.open(this.contextService.configuration.documentation_url, 'target=help');
  }

  redirect(url:string) {
    window.location.href = url;
  }

  logout() {
    this.contextService.logout();
  }

  downloadContext() {
    const context = this.contextService.getJsonContext();
    const app:any = this.contextService.currentApplication;
    app.config = context;
    console.log(JSON.stringify(app));
    const blob = new Blob([JSON.stringify(app)],
      { type: 'text/plain;charset=utf-8' });
    FileSaver.saveAs(blob, 'context.json');
  }

  login() {
    // this.contextService.login(); DEV to remove
    const redirectUrl = window.location.pathname + window.location.search;
    if (this.contextService.termsValidationRequired) {
      this.redirect(`/onegeo-login/terms-of-use?next=${redirectUrl}`);
    } else {
      this.redirect(`/onegeo-login/signin?next=${redirectUrl}`);
    }
  }

  profile() {
    const redirectUrl = window.location.pathname + window.location.search;
    this.redirect(`/onegeo-login/profile?next=${redirectUrl}`);
  }

  cancelEdition() {
    this.contextService.cancelEdition();
    if (this.contextService.currentApplication && !this.contextService.currentApplication.id) {
      this.redirect('#/maps/');
    }
  }

  get currentRouteName() {
    return this.$route.name;
  }

  get mapTitle() {
    return this.contextService.currentApplication?.display_name;
  }

  get canEditMap() {
    if (this.contextService.currentApplication === null
    || this.contextService.currentApplication === undefined) { return false; }

    const currentAppUserGroupId = this.contextService.currentApplication.usergroup;
    if (this.contextService.currentApplication.id === undefined
      || this.contextService.user.is_superuser
      || this.contextService.user.usergroup_roles
        .filter((x:any) => x.usergroup.id === currentAppUserGroupId).length > 0) {
      return true;
    }

    return false;
  }

  get canDeleteMap() {
    if (this.contextService.currentApplication
      && this.contextService.currentApplication.id
      && this.canEditMap) {
      return true;
    }

    return false;
  }

  saveContext() {
    const reload = this.contextService.currentApplication
      && this.contextService.currentApplication.id === undefined;
    if (reload && this.contextService.currentApplication
      && this.contextService.currentApplication.display_name === 'Mon appli') {
      EventBus.$emit(EVENTS.ERROR, 'Il est nécessaire de modifier le titre par defaut');
      EventBus.$emit(EVENTS.OPEN_LEFT_SIDE_MENU, 'SettingsPanel');
      return;
    }
    this.contextService.saveContext().then((app:Application) => {
      if (reload) {
        this.$router.push({ path: `/map/${app.id}` });
      }
    });
  }

  mounted() {
    this.logoUrl = this.contextService.configuration.header.logo;
    // this.mapService = mapservice;
  }
}
</script>

<style scoped lang="less">
.subText{
  font-size: 70%;
}
</style>
